title: Concentric Cylinders 
@warning WORK IN PROGRESS @endwarning

Navigate: [&larr; Benchmark Test cases](../index.html)
| [Test case concentric cylinder Couette flow &rarr;](COC_CoeutteFlow/index.html)

# Concentric Cylinders-Couette Flow Multi-level#

Couette flow between two circular cylinders is used to investigate the behaviour
of velocity boundary condition for complex geometries with q-values.
In this flow, the inner cylinder with radius \(r_1=0.25/2 m\) rotates with a 
constant angular velocity \(\omega=0.213 rad/s\) and the outer cylinder with 
radius \(r_2=0.5 m\) is kept stationary. 

This Couette flow has the following analytical solution
\begin{equation}
 u_\theta(r) = \frac{u_0 \beta}{1-\beta^2}
 \left( \frac{r_2}{r} - \frac{r}{r_2}\right)
\end{equation}
where \(u_0=\omega r_1\) and \(\beta=r_1/r_2\).

The mesh created here is multiple resolutions.
Distance refinement is used to refine towards both inner and outer cylinder
with level=minlevel+2. The element size near the cylinder is similar to 64
elements in inner cylinder of single level mesh.

In these test cases, in addition to the aforementioned features, 
you will also learn how to:

* Create a mesh with boundaries with q-values and distance refinement 
  using Seeder.
* Post-processing nd visualization in Paraview.
* Create a 2D plot using Gleaner tool. Gleaner is a Python tool which
extracts data from Musubi ascii output and uses matplotlib in python library
to create a plot.
